<template>
  <div class="ele-body">
    <el-card shadow="never">
      <!-- 搜索表单 -->
      <el-form label-width="77px" class="ele-form-search">
        <el-row :gutter="15">
          <el-col :md="6" :sm="12">
            <el-form-item label="客户:">
              <el-input
                placeholder="请输入手机号"
                clearable
                v-model="where.title"
              />
            </el-form-item>
          </el-col>
          <el-col :md="6" :sm="12">
            <el-form-item label="客户编号:">
              <el-input
                placeholder="请输入客户编号"
                clearable
                v-model="where.cid"
              />
            </el-form-item>
          </el-col>
          <el-col :md="6" :sm="12">
            <el-form-item label="客户状态:">
              <el-select clearable v-model="where.status" class="ele-block">
                <el-option
                  v-for="(item, index) in statusList"
                  :key="index"
                  :value="item.value"
                  :label="item.label"
                />
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :md="6" :sm="12">
            <el-form-item label="门店:">
              <biz-select v-model="where.bizIds" />
            </el-form-item>
          </el-col>
          <el-col :md="6" :sm="12">
            <el-form-item label="关注车型:">
              <brand-select
                v-model="where.brands"
                type="provinceCity"
                :props="{ multiple: true }"
              />
            </el-form-item>
          </el-col>
          <!--
          <el-col :md="6" :sm="12">
            <el-form-item label="线索归属:">
              <el-cascader
                v-model="where.belong"
                :options="belongOptions"
                :props="{ multiple: true, checkStrictly: true }"
                clearable
              ></el-cascader>
            </el-form-item>
          </el-col>
          -->
          <el-col v-bind="styleResponsive ? { lg: 6, md: 12 } : { span: 6 }">
            <el-form-item label="线索归属:">
              <el-input
                placeholder="请输入工号"
                clearable
                v-model="where.userCode"
              />
            </el-form-item>
          </el-col>
          <el-col v-bind="styleResponsive ? { lg: 12, md: 12 } : { span: 12 }">
            <el-form-item label="筛选日期:">
              <el-date-picker
                unlink-panels
                v-model="where.dateRange"
                range-separator="-"
                type="daterange"
                end-placeholder="结束日期"
                start-placeholder="开始日期"
                :picker-options="pickerOptions"
                value-format="yyyy-MM-dd"
                class="ele-fluid"
              />
            </el-form-item>
          </el-col>
          <el-col :md="6" :sm="12">
            <div class="ele-form-actions">
              <el-button
                type="primary"
                icon="el-icon-search"
                class="ele-btn-icon"
                @click="reload"
              >
                查询
              </el-button>
              <el-button @click="reset">重置</el-button>
            </div>
          </el-col>
        </el-row>
      </el-form>
      <!-- 数据表格 -->
      <ele-pro-table
        ref="table"
        :columns="columns"
        :datasource="datasource"
        :selection.sync="selection"
        cache-key="receiverCustomerTables"
      >
        <!-- 表头工具栏 -->
        <template v-slot:toolbar></template>
        <template v-slot:biz="{ row }">
          {{ row.biz_poi }} <br />
          {{ row.biz_name }}
        </template>
        <!-- 操作列 -->
        <template v-slot:action="{ row }">
          <el-link type="primary" :underline="false" @click="goDetail(row)">
            查看
          </el-link>
        </template>
      </ele-pro-table>
    </el-card>
  </div>
</template>

<script>
  import { getSearch, pageCustomerMobile } from '@/api/receiver/customer';
  import BrandSelect from '@/components/BrandSelect/index.vue';
  import BizSelect from '@/components/BizSelect/index.vue';
  const ROUTE_PATH = '/receiver/customer/mobileList';
  export default {
    name: 'receiverClues',
    components: { BrandSelect, BizSelect },
    data() {
      return {
        mobileId: '',
        where: {
          title: '',
          cid: '',
          citys: [],
          brands: [],
          belong: [],
          bizIds: [],
          userCode: ''
        },
        // 表格列配置
        columns: [
          {
            prop: 'cid',
            label: '客户',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 80
          },
          {
            prop: 'mobile',
            label: '手机号',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 80
          },
          {
            prop: 'biz',
            label: '所属门店',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 80,
            slot: 'biz'
          },
          {
            prop: 'status_name',
            label: '状态',
            align: 'center',
            showOverflowTooltip: true,
            minWidth: 80
          },
          {
            prop: 'brand_detail',
            label: '关注车型',
            align: 'center',
            minWidth: 80,
            resizable: false,
            showOverflowTooltip: true
          },
          {
            columnKey: 'action',
            label: '操作',
            width: 200,
            align: 'center',
            resizable: false,
            slot: 'action'
          }
        ],
        // 表格选中数据
        selection: [],
        // 当前编辑数据
        current: null,
        // 是否显示编辑弹窗
        showEdit: false,
        // 日期时间选择器快捷项
        pickerOptions: {
          shortcuts: [
            {
              text: '今天',
              onClick(picker) {
                const end = new Date();
                const start = new Date();
                picker.$emit('pick', [start, end]);
              }
            },
            {
              text: '昨天',
              onClick(picker) {
                const end = new Date();
                const start = new Date();
                start.setTime(start.getTime() - 3600 * 1000 * 24);
                end.setTime(end.getTime() - 3600 * 1000 * 24);
                picker.$emit('pick', [start, end]);
              }
            },
            {
              text: '最近一周',
              onClick(picker) {
                const end = new Date();
                const start = new Date();
                start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
                picker.$emit('pick', [start, end]);
              }
            },
            {
              text: '最近一个月',
              onClick(picker) {
                const end = new Date();
                const start = new Date();
                start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
                picker.$emit('pick', [start, end]);
              }
            },
            {
              text: '最近三个月',
              onClick(picker) {
                const end = new Date();
                const start = new Date();
                start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
                picker.$emit('pick', [start, end]);
              }
            }
          ]
        },
        belongOptions: [],
        statusList: []
      };
    },
    created() {
      this.loadSearch();
    },
    computed: {
      // 是否开启响应式布局
      styleResponsive() {
        return this.$store.state.theme.styleResponsive;
      }
    },
    methods: {
      loadSearch() {
        getSearch()
          .then((data) => {
            this.statusList = data.statusList;
            this.belongOptions = data.belongList;
          })
          .catch((e) => {
            this.$message.error(e.message);
          });
      },
      goDetail(row) {
        const path = '/receiver/customer/detail';
        this.$router.push({
          path,
          query: row ? { id: row.id, title: row.title } : undefined
        });
      },
      /* 表格数据源 */
      datasource({ page, limit, where, order }) {
        where['id'] = this.mobileId;
        return pageCustomerMobile({ ...where, ...order, page, limit });
      },
      /* 刷新表格 */
      reload() {
        if (this.$refs.table && typeof this.$refs.table.reload === 'function') {
          this.$refs.table.reload({ page: 1, where: this.where });
        } else {
          console.warn('表格引用或 reload 方法不存在');
        }
      },
      /* 重置搜索 */
      reset() {
        this.where = {};
      }
    },
    watch: {
      $route: {
        handler(route) {
          const { path } = route;
          if (path !== ROUTE_PATH) {
            return;
          }
          this.mobileId = this.$route.query.id;
          this.reload();
        },
        immediate: true
      }
    }
  };
</script>
<style scoped>
  ::v-deep .el-cascader__tags input::-webkit-input-placeholder {
    color: white;
    opacity: 0;
  }
</style>
